# pict-rs 0.5.13

pict-rs is a simple image hosting microservice, designed to handle storing and retrieving images,
animations, and videos, as well as providing basic image processing functionality.

## Overview

pict-rs 0.5.13 is a maintenance release aiming to enable better logging in some scenarios.

### Features

- [Colorless Logging](#colorless-logging)


### Changes

- [Remove Flume](#remove-flume)


## Upgrade Notes

There are no significant changes from 0.5.12. Upgrading should be as simple as pulling a new version
of pict-rs.


## Descriptions

### Colorless Logging

When opting to use the `json` logger, the tracing subscriber automatically disables colored output.
This didn't remove colors from errors, though, and pict-rs hasn't had a way to disable colors while
using other log formats. pict-rs 0.5.13 introduces a new configuration value to remove colored
output from all logs regardless of logging format.

With pict-rs.toml
```toml
[tracing.logging]
no_ansi = true
```

With environment variables
```bash
PICTRS__TRACING__LOGGING__NO_ANSI=true
```

With commandline flags
```bash
pict-rs --no-log-ansi run
```

Colors in logs can be useful, so I imagine this option won't be used much. There has been a request
for this functionality though and it's little cost to maintain.


### Remove Flume

Recently I've been debugging a memory usage issue in another project of mine. I wasn't able to fully
track down the cause, but I did notice that removing the
[flume channel library](https://github.com/zesterer/flume) seemed to make the leak go away. Since I
also use flume in pict-rs, I'm opting to replace it with tokio's native channel implementation. This
may or may not improve memory usage, but it does reduce the depenency count and therefore build time
for pict-rs.
